'ATtiny 13V 9,6MHz divide 8
'ADC1 pomiar napicia zasilania (Uz - 0,6)/4
'PB0 - OC0A drugi kana PWM 2 x AMC
'PB1 - OC0B pierwszy kana PWM 1 x AMC
'PB3 - we klik

Dim B As Byte                                               'licznik klikw
Dim C As Byte                                               'zmienna pomocnicza
Dim L As Byte                                               'wskanik trybu
Dim T As Eram Byte                                          'pami trybu
Dim U1 As Word                                              'zmierzone napicie ogniwa, napicie rednie
Dim U As Word                                               'suma 8 pomiarw

Config Pinb.0 = Output                                      'wy PWMA 700mA
Config Pinb.1 = Output                                      'wy PWMB 350mA
Config Pinb.2 = Input                                       'we ADC
Config Pinb.3 = Input                                       'we sterujce

L = T                                                       'odczyt trybu startowego

Wlacz:                                                      'ustalenie wartoci PWM
If L > 5 Then L = 1                                         'sprawdzanie zakresu trybw
If L < 1 Then L = 5
On L Goto Pwm , Tryb1 , Tryb2 , Tryb3 , Tryb4 , Migacz      'skok do ustawienia artoci trybu

Pwm:                                                        'konfig przetwornika
Config Adc = Single , Prescaler = 8 , Reference = Internal
Gosub Nap                                                   'wyczyszczenie bufora ADC
U = 0

Gosub Zero
Do                                                          'zapenienie sumy pomiarw do redniej
Gosub Nap
Incr C
Loop Until C = 7

Config Timer0 = Pwm , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Prescale = 1       'konfig PWM

Pocz:

Do                                                          'ptla gwna

Gosub Zero                                                  'Zerowanie licznika czasu
Do                                                          'ptla odczekujca na zapis trybu po zmianie
If Pinb.3 = 0 Then Goto Zmiana                              'sprawdzenie klika
Gosub 4ms
Gosub Nap
U = U - U1                                                  'odjcie redniej wartoci od sumy pomiarw
If U1 < 505 Then Goto Dol                                   'sprawdzanie min napicia aku (tu dzielnik 10k /2,7k)
Incr C
Loop Until C = 200

Powrot:

If T <> L Then Goto Pamiec                                  'zapis trybu do eprom jeli si zmieni

Loop

Zmiana:                                                     'rozpoznanie klikw
B = 0                                                       'zerowanie licznika klikw
Stop Adc                                                    'zatrzymanie przetwornika ADC
Zegar:                                                      'pomiar czasu klika
Gosub Zero
Do
If Pinb.3 = 1 Then Goto Pomiar
Gosub 2ms
Incr C
Loop Until C = 150                                          'max czas klika

Kierunek:
On B Goto Pwm , Plus , Minus , Bat                          'skok do procedur obsugi klikw
Goto Pwm

Plus:                                                       'tryb w gr
Incr L
Goto Wlacz

Minus:                                                      'tryb w d
Decr L
Goto Wlacz

Pamiec:                                                     ' zapamitanie aktualnego trybu

T = L

Mryg:                                                       'potwierdzenie zapamitania
Config Timer0 = Timer
Reset Portb.0
Reset Portb.1
Waitms 10
Goto Pwm


Pomiar:                                                     'sprawdzanie min czasu przerwy
If C < 5 Then Goto Pwm
B = B + 1
Gosub 4ms

Gosub Zero
Do
If Pinb.3 = 0 Then Goto Zegar                               'oczekiwanie na kolejny klik
Gosub 2ms
Incr C
Loop Until C = 25

Goto Kierunek


Tryb1:
Pwm0a = 0
Pwm0b = 10

Goto Pwm

Tryb2:
Pwm0a = 0
Pwm0b = 70

Goto Pwm

Tryb3:
Pwm0a = 2
Pwm0b = 255

Goto Pwm

Tryb4:
Pwm0a = 255
Pwm0b = 254

Goto Pwm

Migacz:
Config Timer0 = Timer
Reset Portb.1

Do

Set Portb.0
Gosub 4ms                                                   'czas zaczenia

Reset Portb.0

Gosub Zero
Do                                                          'czas przerwy
If Pinb.3 = 0 Then Goto Zmiana                              'sprawdzenie stanu pinb3
Gosub 4ms
Incr C
Loop Until C = 15

Loop

Bat:
Gosub Nap
B = 773 - U1                                                'wyliczenie rnicy pomidzy nap max a zmierzonym
Gosub Zero
If B > 73 Then C = 1                                        'sprawdzanie kolejnych progw napicia
If B > 105 Then C = 2
If B > 115 Then C = 3
If B > 136 Then C = 4

Config Timer0 = Timer
Reset Portb.1
Reset Portb.0
Waitms 80

Do                                                          'ptla odliczajca mignicia
Set Portb.0
Gosub 4ms
Reset Portb.0
Waitms 40
Incr C
Loop Until C = 5
Waitms 50
Goto Pwm

Dol:
If L > 1 Then Goto Minus                                    'obnienie trybu jeli wikszy ni 1
Goto Mryg                                                   'mruganie, jeli tryb ju jest 1

Nap:
U1 = Getadc(1)                                              ' pomiar napicia aku
U = U + U1
U1 = U
Shift U1 , Right , 3                                        'wylicznie redniej wartoci, dzielenie przez 8
Return

2ms:
Waitms 2                                                    'opnienie 2ms
Return

4ms:                                                        'opnienie 4ms
Waitms 4
Return

Zero:
C = 0
Return

End                                                         'KONIEC